#
# Last update: new version for python
#
#
import FWCore.ParameterSet.Config as cms

process = cms.Process("cluTest")
                   
import HLTrigger.HLTfilters.hltHighLevel_cfi as hlt
# accept if 'path_1' succeeds
process.hltfilter = hlt.hltHighLevel.clone(
# Min-Bias	
#    HLTPaths = ['HLT_Physics_v*'],
#    HLTPaths = ['HLT_Random_v*'],
    HLTPaths = ['HLT_ZeroBias_*'],
#    HLTPaths = ['HLT_PAZeroBias*'],
#    HLTPaths = ['HLT_PARandom*'],
#    HLTPaths = ['HLT_PAMinBias*'],
# Commissioning:
#    HLTPaths = ['HLT_BeamGas_HF_Beam1_v*'],
#    HLTPaths = ['HLT_BeamGas_HF_Beam2_v*'],
#    HLTPaths = ['HLT_BeamGas_HF_Beam1_v*','HLT_BeamGas_HF_Beam2_v*'],
#
#    HLTPaths = ['p*'],
#    HLTPaths = ['path_?'],
    andOr = True,  # False = and, True=or
    throw = False
    )

# to select PhysicsBit
process.load('HLTrigger.special.hltPhysicsDeclared_cfi')
process.hltPhysicsDeclared.L1GtReadoutRecordTag = 'gtDigis'

# i do not know what is this doing?
triggerSelection = cms.EDFilter( "TriggerResultsFilter",
    triggerConditions = cms.vstring( 'HLT_ZeroBias' ),
    hltResults = cms.InputTag( "TriggerResults", "", "HLT" ),
    l1tResults = cms.InputTag( "gtDigis" ),
    l1tIgnoreMaskAndPrescale = cms.bool( True ),
    throw = cms.bool( True )
)


process.maxEvents = cms.untracked.PSet(
    input = cms.untracked.int32(1000)
)

process.MessageLogger = cms.Service("MessageLogger",
    cerr = cms.untracked.PSet(
        enable = cms.untracked.bool(False)
    ),
    cout = cms.untracked.PSet(
        enable = cms.untracked.bool(True),
        threshold = cms.untracked.string('ERROR')
    ),
    debugModules = cms.untracked.vstring('siPixelClusters')
)

process.source = cms.Source("PoolSource",
  fileNames = cms.untracked.vstring(    
#  "file:/afs/cern.ch/work/d/dkotlins/public/data/digis.root"
  
## 2012, cosmics
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/791/CEA46376-7069-E111-B395-001D09F24D67.root",
# "/store/data/Commissioning12/Commissioning/RECO/PromptReco-v1/000/186/791/6EC3470C-6F69-E111-93CA-001D09F241B9.root",
# "/store/data/Commissioning12/Cosmics/RECO/PromptReco-v1/000/186/791/6A54D2A0-6D69-E111-ABA8-001D09F2441B.root",
# R186822
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/2C4E0F91-C569-E111-B751-003048D2C01A.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/38A8E118-C969-E111-B30B-003048F117EC.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/3AF5B2FF-C669-E111-8930-003048F024FA.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/48F7CB3D-C469-E111-AB5D-BCAEC53296F8.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/664D8A17-C769-E111-81CA-003048F11114.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/6C772594-C569-E111-ADAE-BCAEC5364C93.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/B29DAEDB-C469-E111-A9DF-0025901D6268.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/BC3CB891-C569-E111-A8A8-BCAEC518FF89.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/BEC6EFFE-C669-E111-BE09-003048F0258C.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/E8CDFC34-CB69-E111-A466-001D09F2AF1E.root",
# "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/186/822/FEC1AA17-C769-E111-BDAE-003048CF94A6.root",
# R 187446
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/FE7B607F-D76D-E111-993E-003048D37538.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/F4E94D8C-D36D-E111-8B8E-0025B3203898.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/F45BE48A-D16D-E111-8873-001D09F25041.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/F2A06371-D36D-E111-89CB-0025901D5D90.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/F01C4674-D36D-E111-B595-5404A63886EB.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/EEC93216-DB6D-E111-A734-BCAEC5329709.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/E447DE30-D86D-E111-928E-5404A63886C7.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/E2193A73-D36D-E111-B41A-E0CB4E4408E7.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/E09580FD-D86D-E111-96FC-003048F1C420.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/E08B0C31-D86D-E111-B44B-E0CB4E55365D.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/D8E4334B-D26D-E111-856A-5404A63886AB.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/CC38AC13-DB6D-E111-8A1B-E0CB4E4408E3.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/CA77838E-D36D-E111-BF84-003048F0258C.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/C8B07B4E-DA6D-E111-A95D-003048F24A04.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/BE506EC4-D66D-E111-B3F5-003048673374.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/BE4F2977-D36D-E111-9884-BCAEC53296F4.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/BC1FA198-D56D-E111-A364-001D09F252E9.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/BC0A2B97-D56D-E111-9878-001D09F24399.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/B8EE564F-DA6D-E111-A3C6-0025B32036D2.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/B07B8B7F-D76D-E111-BB09-003048D2BDD8.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/ACC25274-D36D-E111-862C-BCAEC518FF54.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/AA900C51-DA6D-E111-A4DF-00215AEDFCCC.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/9E5A6448-D26D-E111-B2EC-BCAEC518FF74.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/9C679D51-DA6D-E111-B8FB-002481E0D646.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/98D2E27F-D76D-E111-9DFD-0015C5FDE067.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/8ED12356-DA6D-E111-85F7-001D09F25267.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/8E3DDA51-DA6D-E111-8066-002481E0D958.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/866BDE7F-D76D-E111-B95E-0025B32035BC.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/8666AD8C-D36D-E111-986C-003048F1C424.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/801FD68D-D36D-E111-A36D-BCAEC5329717.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/74E7F77E-D76D-E111-9572-003048D2C16E.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/72C42773-D36D-E111-915A-BCAEC518FF41.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/72AF0133-D66D-E111-837F-003048D2BC38.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/7280F888-D16D-E111-B684-001D09F295FB.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/702B534F-DA6D-E111-BD9A-001D09F29619.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/5AB938FD-D86D-E111-BC54-003048F024FA.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/5A8B532F-D86D-E111-8F81-5404A63886C4.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/58D3E574-D36D-E111-97FA-BCAEC5329705.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/56941D79-D36D-E111-AB00-BCAEC5329719.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/563B1597-D56D-E111-94D5-002481E0D73C.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/54EF4674-D36D-E111-9019-BCAEC5329713.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/5427C280-D76D-E111-8948-001D09F242EF.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/4EF9C201-D56D-E111-825E-00215AEDFD74.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/3EA8C331-D86D-E111-A427-001D09F2A690.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/3E4BCC7C-D76D-E111-BCCF-003048F11114.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/3C6C6C51-DA6D-E111-99CA-00237DDBE49C.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/3AE663DF-D26D-E111-964E-BCAEC518FF44.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/32F29045-D26D-E111-98C6-BCAEC5364C4C.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/2EA3407F-D76D-E111-9847-002481E0DEC6.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/2E137EFD-D86D-E111-9CBC-0025B32035A2.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/28BE4756-DA6D-E111-8899-003048F11DE2.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/2010C213-DB6D-E111-99CC-5404A63886D6.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/1E1641BD-DB6D-E111-B1EB-003048F1C832.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/1C15184F-DA6D-E111-BA10-003048F118C4.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/1A5F5A56-DA6D-E111-A8DD-003048F11942.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/06681347-D26D-E111-8005-E0CB4E4408E3.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/04E47C26-DD6D-E111-8D1C-003048F024F6.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/0233A574-D36D-E111-91C3-BCAEC5364C42.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/187/446/0228C49A-D56D-E111-A48B-001D09F24EE3.root",

# 190389 (ran OK, no zb)
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/009B5147-9F80-E111-90B5-001D09F2424A.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/06DD07A7-A080-E111-AA52-0015C5FDE067.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/06FF4150-AA80-E111-B82A-5404A63886B0.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/0E8628A8-A080-E111-AA55-001D09F292D1.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/0EE8D651-AA80-E111-9B0C-5404A63886EF.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/10976EFE-9180-E111-9390-5404A63886B6.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/1A0F5A0C-AD80-E111-BA2A-BCAEC5364C93.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/1A806611-AD80-E111-B702-001D09F2A690.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/220A939E-B180-E111-806C-003048CF94A6.root",
## "/store/data/Commissioning12/MinimumBias/RECO/PromptReco-v1/000/190/389/260242F4-B080-E111-AE76-00215AEDFD74.root",

# "/store/express/Commissioning12/ExpressPhysics/FEVT/Express-v1/000/190/411/0280693C-F87E-E111-9911-BCAEC532970F.root",

# run 191271
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/0C745F0F-BE88-E111-9978-485B3977172C.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/0EC6C2CC-B288-E111-93DB-001D09F24353.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/7A86F1C4-B988-E111-BF91-00215AEDFCCC.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/7C042DFF-B488-E111-8171-5404A640A642.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/8CC241CE-B288-E111-8320-001D09F29321.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/AAD273EC-BB88-E111-891A-BCAEC5329713.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/B20AAA76-B688-E111-A69E-BCAEC5364C42.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/B43F5CB7-C388-E111-BBB3-5404A63886EF.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/B60FA7FF-C288-E111-B5D7-5404A6388699.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/C84D5FFB-B488-E111-B0BE-5404A6388694.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/D0E4D5F9-B488-E111-9E82-BCAEC518FF41.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/271/D6F911A0-BC88-E111-A1C9-BCAEC518FF7A.root",

# 191411
#  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/411/66FD8F4B-088A-E111-A96C-001D09F252E9.root",

# 191718
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/2AB8ED3A-B88B-E111-A086-5404A6388692.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/3CCF1232-D28B-E111-8E14-001D09F2424A.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/46F6126B-D68B-E111-8895-003048F11114.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/52075473-C58B-E111-95CD-0015C5FDE067.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/AC4A5932-D28B-E111-BD5F-001D09F24FEC.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/B42DACB6-CE8B-E111-A6DC-001D09F23C73.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/C0241E8A-CC8B-E111-B8A4-001D09F24303.root",
# "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/191/718/F2E89EB6-CE8B-E111-8F33-0019B9F4A1D7.root",

# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/44DC8D5C-DB8B-E111-B786-5404A63886B2.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/46C834F6-D98B-E111-A1D7-5404A638869E.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/4E7B5EAE-CE8B-E111-9E02-001D09F29114.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/8057AD53-E08B-E111-B0B3-485B39897227.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/8801A26B-D68B-E111-A0FC-002481E0DEC6.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/A028490E-D08B-E111-8D6D-0025901D627C.root",
# "/store/data/Run2012A/Commissioning/RECO/PromptReco-v1/000/191/718/DE0D2BA4-DA8B-E111-A55A-0025B320384C.root",

# fill 2576
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/10CC3327-9B95-E111-A670-001D09F2A465.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/1AA80E34-8C95-E111-A50D-001D09F24FBA.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/801B1A24-8F95-E111-B7F8-003048D2C108.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/86223BA8-8795-E111-9FEB-BCAEC5329713.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/903C8452-9395-E111-A3EC-001D09F2905B.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/9E6FE753-8995-E111-AE3B-003048F118E0.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/A6D3BB38-8795-E111-ADF6-BCAEC518FF6E.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/B48B8874-9095-E111-9A6A-003048F11C5C.root",
#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_ZeroBias/RECO/PromptReco-v1/000/193/092/DA2D45C9-8995-E111-88A1-0025901D631E.root",

#   "rfio:/castor/cern.ch/cms/store/data/Run2012A/LP_MinBias1/RECO/PromptReco-v1/000/193/092/002CD9DE-8995-E111-869C-001D09F2AF1E.root",

# fill 2596, 
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/1E63A782-8B9A-E111-97CF-001D09F2B30B.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/20257BCD-8F9A-E111-9EE4-001D09F25460.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/3CDAD5EC-949A-E111-9B86-003048D2BC42.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/4C13AD2F-919A-E111-A327-001D09F2B30B.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/5E47D39E-929A-E111-89A8-001D09F25267.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/72295CE6-949A-E111-B7DB-003048F1C836.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/7AC6A094-989A-E111-9F81-001D09F2512C.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/82FD1049-999A-E111-B882-003048F024FE.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/94441B27-949A-E111-93D1-003048F1BF68.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/A0EAD5B6-9C9A-E111-89BB-BCAEC518FF6B.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/A8869045-8C9A-E111-8D13-001D09F27003.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/AAF776F5-8C9A-E111-B091-001D09F25460.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/B05A6127-949A-E111-A824-003048CF9B28.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/B6ED0C24-8A9A-E111-AA86-0019B9F72D71.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/BA234F8A-939A-E111-9F84-001D09F241B9.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/CA8D40AC-8D9A-E111-A572-001D09F244DE.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/CC0FE027-949A-E111-9390-003048F118DE.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/CE296C9F-929A-E111-8748-001D09F244DE.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/D8D77840-8C9A-E111-9332-001D09F2447F.root",
##  "/store/data/Run2012A/MinimumBias/RECO/PromptReco-v1/000/193/621/FEF2BAC8-999A-E111-A3DC-485B3977172C.root",

##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/161575BF-339D-E111-B009-485B3977172C.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/5464CD17-329D-E111-8062-5404A63886BE.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/8271BC4A-2F9D-E111-891F-003048F11C28.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/84AE016A-319D-E111-9EB2-5404A63886C0.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/C67F52B9-419D-E111-98E9-003048D37560.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/D2897664-2A9D-E111-AE88-003048D2BC52.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/DCBD02EA-399D-E111-966F-BCAEC518FF68.root",
##    "rfio:/castor/cern.ch/cms/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/193/998/E8BA354A-2F9D-E111-BEC6-0015C5FDE067.root",

# fill 2621
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/0E3C3137-179E-E111-9A06-5404A63886C5.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/0E727127-159E-E111-AC08-00215AEDFD74.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/102488EE-3C9E-E111-B275-003048D3733E.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/16F23FD3-269E-E111-90F3-0025B320384C.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/20D96233-179E-E111-9BCD-BCAEC5329702.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/261AE52F-429E-E111-8BAE-0025901D5DF4.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/2638B30A-309E-E111-8973-BCAEC518FF6E.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/268D0C20-269E-E111-9561-003048D2BD66.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/44301897-0F9E-E111-82A4-003048D374F2.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/6213E48B-119E-E111-BA26-0030486733B4.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/68790229-1C9E-E111-84F2-003048D2BC4C.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/6C1ECA8D-0F9E-E111-93BC-002481E0D7C0.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/6C301D9C-0F9E-E111-B74C-BCAEC5364C93.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/743C1AC6-1A9E-E111-9B5D-00215AEDFCCC.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/762082AC-139E-E111-816F-0025901D631E.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/7A1FF1BF-1A9E-E111-AFBA-002481E0D7EC.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/880CCD28-1C9E-E111-9664-003048D2BC38.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/92236757-149E-E111-8389-002481E0D73C.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/92E3A46D-0F9E-E111-8A45-E0CB4E553651.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/A03F677E-229E-E111-8D0C-003048D2BC4C.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/A0DEB0E1-179E-E111-A3AF-003048F1C82A.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/A6ABBAF3-0F9E-E111-90A2-001D09F2437B.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/B0C7F697-189E-E111-A9E0-003048D37538.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/B6460AFE-199E-E111-A3A2-003048D374CA.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/B8F5592F-429E-E111-BDF6-5404A63886AB.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/BE90BB55-149E-E111-95B9-003048F118DE.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/C4225BD2-0F9E-E111-A17A-BCAEC5364C42.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/CEBEC4A4-0F9E-E111-A9B1-003048D37538.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/D28804BE-1A9E-E111-90F9-0025B32035BC.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/D2B5D280-119E-E111-915D-5404A63886D2.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/DE912530-139E-E111-AAE6-0030486780B4.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/F6587C8E-519E-E111-A914-5404A63886AD.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/FEDC688B-279E-E111-9EF7-0025901D62A0.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/16A57AB6-649E-E111-9D6D-001D09F28F25.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/5457E6EE-489E-E111-81DA-5404A63886E6.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/9ADAB38B-519E-E111-B3A4-BCAEC5329717.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/A44197F4-579E-E111-8264-003048D2BE06.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/BA6CD7F5-579E-E111-A79D-003048D2BB90.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/C4A51D8C-519E-E111-A84B-5404A638868F.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/0E3ABC62-499E-E111-9BD7-485B3962633D.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/050/887E0357-5E9E-E111-99DC-0025901D5D80.root",

# fill 2663
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/00471167-82A8-E111-B467-BCAEC53296F3.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/0E6700C0-25A8-E111-93C0-003048D2C108.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/0ECA6CAF-89A8-E111-895D-5404A63886B1.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/101E6F20-5CA8-E111-8806-BCAEC5329709.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/103AD8C4-64A8-E111-8049-003048D2BC42.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/1470FC66-3CA8-E111-ABED-003048D2C01A.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/16DDF92A-66A8-E111-9C6D-001D09F23174.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/1E2AEDB0-60A8-E111-B148-5404A63886EC.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/1EFEA2DF-1BA8-E111-97F0-001D09F24353.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/22826145-2EA8-E111-8ABF-001D09F292D1.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/24E517CB-64A8-E111-8521-0030486780B8.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/264A3786-91A8-E111-A791-BCAEC518FF80.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/28C2B478-5CA8-E111-88C0-BCAEC532971E.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/2A6C9B7B-80A8-E111-8EF0-E0CB4E5536AE.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/2E4C455F-9BA8-E111-B1B0-003048D3751E.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/2EBC8E96-5FA8-E111-BF27-BCAEC532970F.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/328F7379-A2A8-E111-B1BC-001D09F297EF.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/367D5007-D2A8-E111-B369-0025901D5C88.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/3805738A-9DA8-E111-889D-003048D2C0F4.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/384D77E3-1BA8-E111-988D-0025901D5DB2.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/544C491F-5CA8-E111-A7F0-BCAEC532971D.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/54AF243E-72A8-E111-9FBA-003048F118C6.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/6418506B-41A8-E111-A313-001D09F24DA8.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/68C64FBF-36A8-E111-A588-0025901D5D7E.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/6AE7927D-80A8-E111-98D3-E0CB4E4408E7.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/722C7109-5BA8-E111-BA78-0025901D62A0.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/741E027E-3EA8-E111-B23E-BCAEC5329716.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/74E1E304-4FA8-E111-BF2D-003048D2C01E.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/76E4A9E1-97A8-E111-AD5E-003048D2C020.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/7CE53D59-35A8-E111-BE61-003048D37580.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/8E480FB0-60A8-E111-9AC3-BCAEC518FF54.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/8E98112E-36A8-E111-BB0E-5404A63886CF.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/90725E0D-5BA8-E111-A7BF-5404A6388694.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/96AC63B1-53A8-E111-B916-5404A6388698.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/98D4701A-7CA8-E111-8281-BCAEC518FF74.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/A6187646-94A8-E111-8444-001D09F29533.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/A8DAE671-61A8-E111-AAEA-0025B3203898.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/AA15F3EF-99A8-E111-AF0E-003048D2BC52.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/B035818D-98A8-E111-B805-003048D373AE.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/B0E3C7D0-3DA8-E111-B0F1-5404A63886B2.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/B20E582B-A8A8-E111-8BFE-001D09F2527B.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/B427EA9A-A9A8-E111-9E21-001D09F25460.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/B43B7388-1FA8-E111-866E-001D09F24DA8.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/BC322A0E-70A8-E111-90F8-003048D2BD66.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/C4421C8B-9DA8-E111-8FE5-00237DDBE41A.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/C4695770-65A8-E111-96DB-BCAEC53296F8.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/CADF58A6-34A8-E111-B24D-0025B32445E0.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/CC08A75D-6DA8-E111-A049-001D09F2447F.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/D08E43A4-87A8-E111-AB98-485B3962633D.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/D439CAEF-33A8-E111-B362-BCAEC518FF52.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/D6097E1A-A6A8-E111-BEEB-5404A63886A0.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/E8F99B4E-52A8-E111-905B-BCAEC53296F8.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/F2C035BD-69A8-E111-B021-003048F1BF66.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/F8A3A8A1-4CA8-E111-9481-BCAEC518FF8D.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/FC394E53-24A8-E111-A17D-003048F118C6.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/FCCD33CD-B7A8-E111-B7F1-003048D2C01E.root",
##     "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/194/912/FEC82608-A1A8-E111-B4CD-BCAEC518FF50.root",

# fill 2670

## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/EA8428A6-6BAA-E111-90B6-485B3962633D.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/E20CB792-5CAA-E111-9CBC-003048D37666.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/A2DB76A2-44AA-E111-872A-5404A638868F.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/78E58267-66AA-E111-9505-BCAEC5364C4C.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/4475310E-65AA-E111-A450-BCAEC518FF52.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/40AB4A06-72AA-E111-83E5-0025901D5DB2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/32B9AA8E-61AA-E111-B6F5-003048F118AA.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/2AAD3A6B-59AA-E111-8ED7-0025901D629C.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/1AC3A20F-6FAA-E111-9A64-BCAEC53296FB.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/06BB53B2-73AA-E111-B98A-003048F117B4.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/099/024EFA12-60AA-E111-BA44-E0CB4E553673.root",

    
# fill 2671
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/26682BC3-EAAA-E111-8D66-002481E0D7EC.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/2627AD36-F0AA-E111-93B7-003048D2C16E.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/30AA5C32-E0AA-E111-A2E5-5404A63886B4.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/5E44AA1A-ECAA-E111-ADC1-BCAEC518FF52.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/5E7E23B0-F8AA-E111-A69F-5404A63886B9.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/7A2DAF17-E5AA-E111-ADD1-0025901D6288.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/8EEDAF3D-0DAB-E111-8D24-003048D2BE08.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/B22F7F59-E4AA-E111-B424-BCAEC518FF89.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/B2D4DCA8-F6AA-E111-BFAC-5404A638869E.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/BC8ACBB7-FCAA-E111-A853-0025901D5DB2.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/C4ABF907-00AB-E111-B9A1-0025901D626C.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/C800A10C-00AB-E111-9077-003048F11CF0.root",
##   "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/109/EA16EF88-02AB-E111-88D7-002481E0D790.root",

# fill 2712
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/FC8E7F2E-71B3-E111-BB47-003048D3C980.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/E0C9E8C7-63B3-E111-ABED-003048F11942.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/D8FEDF23-8EB3-E111-893A-003048F118C2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/D42341D5-14B3-E111-AB6A-001D09F2910A.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/D20E09CA-05B3-E111-8CC6-485B39897227.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/CA5DD02C-71B3-E111-A055-003048D3756A.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/C4B0B7BD-3DB3-E111-ABEC-003048F118AC.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/C40F632F-71B3-E111-A14B-003048D2BBF0.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/C409FE7D-FCB2-E111-8669-003048F118C6.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/C273B1DB-1EB3-E111-BBC2-BCAEC5329717.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/B2F74F91-10B3-E111-BB98-001D09F2A690.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/B0B3A13D-21B3-E111-A08F-001D09F2525D.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/A8C73DC4-42B3-E111-9B8F-001D09F295FB.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/A4E62C1E-48B3-E111-9733-5404A6388692.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/98B4A3D4-12B3-E111-BADA-0025901D5DB8.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/981E1BF9-02B3-E111-A155-003048D3750A.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/9015A3AB-74B3-E111-A605-001D09F24303.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/900DA09E-FBB2-E111-A068-5404A63886C4.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/8EE22EF5-FCB2-E111-9E12-E0CB4E553651.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/8CA02797-41B3-E111-996B-BCAEC518FF80.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/8A86F139-78B3-E111-93D0-001D09F23174.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/84EC2056-0EB3-E111-9FB8-BCAEC5329709.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/7ED3B246-28B3-E111-A4A0-BCAEC518FF44.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/6A6E2CB7-25B3-E111-AD7D-003048F024C2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/6858C9F5-84B3-E111-956E-001D09F2924F.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/5EE9BC9B-A5B3-E111-9549-003048D3750A.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/4EA0E383-6DB3-E111-994D-0025901D624E.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/4CA14E2C-42B3-E111-8DDF-5404A63886C6.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/3EDDF63F-21B3-E111-8E50-001D09F23C73.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/366E7FDF-F7B2-E111-9236-003048F1183E.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/345C88B1-03B3-E111-83FA-003048F117F6.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/2A2B5349-5EB3-E111-BD9C-001D09F2841C.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/2252F549-24B3-E111-BD1C-BCAEC518FF6B.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/224874A1-4DB3-E111-A6E8-BCAEC518FF76.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/1CCBD219-54B3-E111-8117-0025901D6268.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/1C584E1B-54B3-E111-8675-5404A63886B6.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/109D50B0-79B3-E111-A0EE-001D09F24303.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/06F334FC-0CB3-E111-BA49-5404A63886A0.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/195/774/04E0B480-FAB2-E111-995A-003048F11114.root",

# fill 2739
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/EA14CD67-FBBA-E111-9E54-0015C5FDE067.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/EA143873-02BB-E111-879A-001D09F25041.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/D864DC90-FDBA-E111-AB59-001D09F2447F.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/D0FE1038-F9BA-E111-8CA2-003048D2C092.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/CECA8AD0-08BB-E111-A4A8-003048D2C092.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/CA48FDED-F9BA-E111-8EEF-003048D375AA.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/C073FC49-00BB-E111-B0EA-003048D374F2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/7011E9E6-0ABB-E111-A5CD-BCAEC5329702.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/669D6022-03BB-E111-A41B-003048D2C092.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/64BC6062-FBBA-E111-A5F5-001D09F2A465.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/628479F6-05BB-E111-8386-003048D2C020.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/5E6A478B-FDBA-E111-BF6D-001D09F27067.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/4E5F98E8-0ABB-E111-9A1F-BCAEC5364C4C.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/38306919-08BB-E111-AE8F-001D09F29169.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/323D086C-F6BA-E111-9C42-003048D374F2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/2438DA6B-FBBA-E111-9493-003048F01E88.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/18CF61CB-FCBA-E111-AFE9-003048D374F2.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/121B0271-02BB-E111-AE1C-001D09F25460.root",
## "/store/data/Run2012B/MinimumBias/RECO/PromptReco-v1/000/196/531/0CE99CF6-05BB-E111-A3FD-003048673374.root",
 
# fill 2865, high PU
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/F4A50C72-2CCD-E111-9FE5-001D09F276CF.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/E233D83D-28CD-E111-AF07-001D09F2924F.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/C0C2D2F3-28CD-E111-8599-001D09F2A465.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/BEED0F57-23CD-E111-BF8B-0019B9F72CE5.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/BE589B78-33CD-E111-8CB6-001D09F28E80.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/B25F5628-2DCD-E111-B057-0019B9F72CE5.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/A62801FA-2FCD-E111-A105-001D09F24EE3.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/9AE138C7-37CD-E111-8F87-001D09F251FE.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/76FADBC2-2BCD-E111-8227-001D09F29146.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/681CCA4D-21CD-E111-B409-001D09F23F2A.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/66687A98-27CD-E111-A411-001D09F25267.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/62BE0501-37CD-E111-B316-001D09F242EF.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/3070DF12-2BCD-E111-89E8-001D09F2462D.root",
## "/store/data/Run2012C/ZeroBias/RECO/PromptReco-v1/000/198/609/0E478DDC-26CD-E111-90D2-001D09F2B30B.root",

# fill 2855 (VDM?)
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FEE0ADFD-77D3-E111-A45A-003048F1C424.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FE9FFD87-D4D3-E111-B40A-003048F1C836.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FE78951D-B0D3-E111-9397-BCAEC518FF65.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FE385AFE-81D3-E111-9634-BCAEC53296F3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FC0E084C-D5D3-E111-B070-003048F1BF68.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/FACD5C14-B5D3-E111-A08E-003048F024C2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F88FAE24-B6D3-E111-B736-002481E0D646.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F807D5DF-93D3-E111-93BE-0025B32035A2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F6FD9200-CBD3-E111-AD7D-BCAEC532971C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F6741513-B5D3-E111-BDDD-003048F24A04.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F4B41F88-D4D3-E111-8960-002481E0D7D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F4907CF6-78D3-E111-B2A3-003048D37694.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F2C3FAE0-93D3-E111-96E8-001D09F292D1.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F29AF713-B5D3-E111-A214-BCAEC518FF80.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F291886D-C9D3-E111-B075-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F258E7B2-C2D3-E111-A7F8-BCAEC5364CFB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/F0C356E4-A4D3-E111-91DB-BCAEC518FF8E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/EE3BB526-7FD3-E111-824A-BCAEC518FF8F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/EE37D177-8ED3-E111-95B6-003048D2BC52.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/EADF0246-8BD3-E111-BDAB-003048D2C020.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/EACA0766-8AD3-E111-A75F-BCAEC518FF54.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/EABF3CE2-93D3-E111-B797-002481E0D90C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E6BB052A-C2D3-E111-9602-BCAEC518FF7C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E6325DF1-9FD3-E111-8756-00237DDC5CB0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E4D7BE73-A5D3-E111-80A7-003048678098.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E48CBF8B-AAD3-E111-ABC4-00237DDBE0E2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E47CCB14-D5D3-E111-BE3C-003048D37456.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E44EDE00-78D3-E111-B76C-003048D2BE06.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E2A51DF7-9CD3-E111-9EB6-003048F0258C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E27E7BCE-84D3-E111-BD2F-003048F11112.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E27E22EC-D3D3-E111-8DB5-001D09F23A20.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E01F7C34-CFD3-E111-B928-E0CB4E4408E7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/E0043FE1-93D3-E111-A90D-001D09F24024.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DECA8B8E-94D3-E111-9DCE-003048678098.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DC7A921D-A1D3-E111-BC44-001D09F23A20.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DC70E9E2-93D3-E111-B22E-0030486733B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DC295D7E-CBD3-E111-97AD-003048F1C420.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DC25AAD5-B7D3-E111-A7FB-0025901D5DEE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DABB0276-A8D3-E111-96B1-002481E0DEC6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DAA6DC80-ABD3-E111-9E93-5404A640A648.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/DA9572C7-C6D3-E111-9136-003048D2BBF0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D8FC0934-C2D3-E111-B507-001D09F29524.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D6CCD28E-94D3-E111-AB81-001D09F28F25.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D6B7434A-D7D3-E111-9B05-003048F024F6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D6635452-90D3-E111-8A01-BCAEC518FF80.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D4A7E74B-D5D3-E111-A7F9-5404A63886B6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D45C8E81-A3D3-E111-9BCD-BCAEC518FF30.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D2CA4B1D-7AD3-E111-B93D-BCAEC5329701.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D2A9E4AD-9ED3-E111-9724-001D09F2AD4D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D0D05F23-B6D3-E111-B910-002481E0D7C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D08BBBEA-82D3-E111-8B2D-001D09F2A465.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/D06A767A-A9D3-E111-B482-BCAEC5329716.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/CE99E4EA-A2D3-E111-A3D2-002481E94050.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/CE5ABDEF-9FD3-E111-97AE-001D09F253C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/CCE71BFA-83D3-E111-A3C0-0025901D5E10.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/CCCE46DB-81D3-E111-A438-003048F1110E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/CCA53F6C-8FD3-E111-BD81-5404A63886B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C8367534-6ED3-E111-8AB7-0025901D5C88.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C68D927A-CED3-E111-AE86-BCAEC5364CED.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C66E58E3-D2D3-E111-97BB-002481E0D646.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C66AC1E0-B1D3-E111-93B7-003048F0258C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C42D9DD8-81D3-E111-A807-001D09F29597.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C408CFB2-C2D3-E111-9D2E-0025901D625A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C2A48E61-BAD3-E111-AE07-003048F024E0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C2A488FF-81D3-E111-A7B3-0025901D5D9A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C29FF01D-A1D3-E111-88CF-003048D3C982.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C267FC8A-ABD3-E111-8D4D-5404A63886C3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C053E8DD-D7D3-E111-A2D1-0019B9F72F97.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/C0396F14-D5D3-E111-9427-003048678110.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BEE8D9CA-84D3-E111-828D-0025901D5DEE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BEAD99B2-C2D3-E111-8387-BCAEC53296FB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BE761E36-97D3-E111-916D-001D09F24024.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BC94AEC0-83D3-E111-B60F-001D09F291D7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BC603D35-6ED3-E111-9757-5404A638869E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BAF74AED-9FD3-E111-B9A6-003048CF94A6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BA53E5CB-D4D3-E111-9EF9-BCAEC518FF5F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/BA0C0F29-D1D3-E111-948C-5404A63886AB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B6F5155B-77D3-E111-9F39-001D09F24399.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B4F6A26B-8FD3-E111-86BC-BCAEC518FF54.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B4BB9D65-8AD3-E111-8022-BCAEC5364C93.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B496F3A2-7BD3-E111-81E4-E0CB4E5536AE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B26C3C64-D9D3-E111-BA49-001D09F24024.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B0FF3272-85D3-E111-A75C-0025901D5DF4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B0F9A071-96D3-E111-9272-BCAEC532971E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B0DE33FF-81D3-E111-AF0B-5404A640A63D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/B0BC86C0-6CD3-E111-9DEE-003048D2BBF0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AEA9543F-BCD3-E111-9D1C-0025901D6272.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AE8A75FF-77D3-E111-A542-5404A638869B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AE4533A9-87D3-E111-BFC6-BCAEC518FF67.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AC84E233-CFD3-E111-A94A-BCAEC532971C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AC2A0080-CED3-E111-99ED-003048D2C01A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/AC19DAE4-D2D3-E111-B725-0030486780A8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A81CD9C7-A1D3-E111-A3B0-001D09F23174.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A66E8800-8DD3-E111-AEB9-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A60CD91A-7AD3-E111-95D7-BCAEC532971C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A2DEDF1E-A1D3-E111-A2CE-001D09F23D1D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A0E68DCD-84D3-E111-9312-003048F11C28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/A077A3B1-C2D3-E111-92C9-BCAEC518FF65.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9EA2AEEA-C8D3-E111-B343-0025901D631E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9E60D9CD-84D3-E111-AB59-BCAEC518FF8A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9CC693E3-D2D3-E111-BA37-0025901D5C86.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9CABA7D7-81D3-E111-A6C2-003048F11DE2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9AFD4A6A-C9D3-E111-8068-5404A63886C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9A7D5BB3-C2D3-E111-B4C3-5404A63886A5.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9842DE49-D7D3-E111-8AA5-003048CF9B28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/981D92F4-CFD3-E111-B0DA-0025901D5DF4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/96E7042D-DAD3-E111-85C3-001D09F2305C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/96B65458-90D3-E111-AC0E-001D09F2B30B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/94F73000-78D3-E111-8A38-00237DDC5BBC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/941477EE-A3D3-E111-82EB-BCAEC5364C4C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/9238BEBA-AAD3-E111-96E4-0025901D5D78.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/908BCD9B-AAD3-E111-9C37-003048D2BF1C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/905FFB27-D1D3-E111-B78B-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8EBD8DC1-6CD3-E111-8D46-0030486733D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8E53D46C-8FD3-E111-98C6-5404A63886AB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8CD297FD-77D3-E111-BA36-002481E94C7E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8C97989C-C7D3-E111-A9A5-001D09F241B9.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8AC7DE91-7CD3-E111-B972-003048D2C020.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/8A2002EB-74D3-E111-BF75-003048D3C982.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/88C4D516-B5D3-E111-B038-0030486780B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/88A17664-C6D3-E111-B645-003048D37560.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/86DA94A6-7FD3-E111-845F-001D09F28D4A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/86BD408F-94D3-E111-B835-001D09F29146.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/86B83EC1-AFD3-E111-8229-003048D2BED6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/80991280-CED3-E111-A014-0030486780B8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7EEF5919-BDD3-E111-A9A0-001D09F252DA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7C8926A5-9FD3-E111-87AE-001D09F25267.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7C442963-D3D3-E111-B84F-0025901D5E10.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7AF938D8-B9D3-E111-A832-001D09F290CE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7A158772-79D3-E111-BBE7-001D09F242EF.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/785AFF76-CDD3-E111-9077-001D09F29146.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/768D12F2-9AD3-E111-A2D2-E0CB4E5536AE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7447E31C-88D3-E111-BA8A-BCAEC518FF63.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/7445F477-CDD3-E111-B11F-003048D2BE06.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/742696CA-84D3-E111-A625-BCAEC5329716.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/72C7C1CD-84D3-E111-B1B2-5404A63886C5.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/70EABFD8-6ED3-E111-AAE6-003048D37694.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/70D82516-B5D3-E111-9F8C-5404A6388694.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/6E74C778-D5D3-E111-A40F-0025901D5C86.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/6AFCBCF5-CFD3-E111-8CCD-BCAEC532971F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/68FA5519-EFD3-E111-8C3B-5404A6388698.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/68B4AF34-CFD3-E111-B13A-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/6659193F-8BD3-E111-9816-003048F11C28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/6658B2E6-D2D3-E111-AC2A-003048F11C28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/64FA2A8A-A3D3-E111-AF59-0030486780A8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/62C1DF28-D1D3-E111-A3DB-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/627CC97D-BED3-E111-AC6A-0025901D5E10.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/6226DCDA-81D3-E111-BAB2-001D09F25041.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/60BFF0E0-93D3-E111-81E8-001D09F2932B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/603B763E-BCD3-E111-8269-BCAEC518FF76.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/60049947-72D3-E111-9F35-BCAEC532971E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5EED2C0D-73D3-E111-800E-003048D2BE08.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5EB9EFF3-98D3-E111-A6FB-001D09F253D4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5E68F0FB-77D3-E111-ACE0-BCAEC518FF74.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5E5B7F7A-A9D3-E111-8ABF-BCAEC5364CFB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5E1A619D-C7D3-E111-BBD9-001D09F24024.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5CC18056-81D3-E111-9EF7-001D09F2A690.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5C5F24C1-75D3-E111-9D2C-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5AC576AD-D7D3-E111-BF55-001D09F2A690.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5A90C4EE-C8D3-E111-89AE-BCAEC532971D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5A834EE9-74D3-E111-AE6F-001D09F2305C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5A665A3E-D6D3-E111-8CAB-BCAEC5329713.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5A400C30-D1D3-E111-BD3A-001D09F2305C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/58E372F7-CFD3-E111-B4BE-5404A640A63D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5689077C-A9D3-E111-BEA7-BCAEC518FF6E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/54591156-98D3-E111-AED6-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/541775EA-82D3-E111-8B2A-001D09F25479.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/52C99010-D7D3-E111-BAD8-BCAEC5364C93.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/52518C2B-8ED3-E111-A836-003048D2BD66.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/5238DAAE-9ED3-E111-A9E3-001D09F2915A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/520CBAA8-87D3-E111-953A-BCAEC5329708.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/50B2FD23-B6D3-E111-9B81-003048F118E0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/505A1365-C6D3-E111-9EFB-003048678098.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/50211FC1-83D3-E111-AB95-0019B9F70468.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4EEA8D9E-84D3-E111-A6AA-002481E0D790.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4E061FEF-9FD3-E111-92CA-001D09F24FBA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4CEA342C-8ED3-E111-A882-003048D2BB90.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4CA39686-D7D3-E111-9BBC-001D09F34488.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4C8F8A61-AED3-E111-A3CF-E0CB4E553651.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4AB8C98D-94D3-E111-9D6C-002481E0CC00.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/48760A39-97D3-E111-9C7A-001D09F2932B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/46D7A527-D1D3-E111-85DE-E0CB4E553673.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/44B32FE3-B1D3-E111-88DF-003048F117EC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/42CFCB63-C6D3-E111-8B69-BCAEC5329720.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/40B31CCD-C0D3-E111-A7DE-5404A638869E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/4027D534-6ED3-E111-9439-BCAEC518FF7C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/40040E3F-BCD3-E111-BF23-0025901D6288.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3EAD79C9-A1D3-E111-BA58-001D09F241B9.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3E2EEEA3-6DD3-E111-AB58-003048678098.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3E13E029-8ED3-E111-9C49-0030486780EC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3CD68EB2-C2D3-E111-82F5-0025901D631E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3AA93C36-D4D3-E111-A6EE-0025901D624A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3A3AF5A7-87D3-E111-97BD-BCAEC5364C93.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/38C97BDA-6ED3-E111-876D-001D09F2983F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/38C51F5F-AED3-E111-8530-5404A63886C1.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/38AF10E5-A2D3-E111-8253-003048F1C58C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/386FDDD8-81D3-E111-8B7B-001D09F241B9.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/36DD2B73-96D3-E111-8A6E-5404A63886A8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/368EB4F5-CFD3-E111-B373-0025901D5C80.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/368E04F6-CFD3-E111-B6D9-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/34E40D33-C2D3-E111-B344-003048F110BE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/349C9388-D4D3-E111-9D5A-00237DDBE49C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/32B8CAE2-74D3-E111-9AB7-BCAEC518FF6B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/3297F10E-C5D3-E111-819C-003048D2C01E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/2CB81972-79D3-E111-8B6A-0025B32035A2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/2C682764-BAD3-E111-AF06-00237DDC5CB0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/28691FED-BED3-E111-9EC4-5404A63886CC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/26E927FE-77D3-E111-9AB3-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/26E37BEB-82D3-E111-B0BA-003048D2BC4C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/26A88391-92D3-E111-BC8F-003048CF9B28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/269AAD20-A1D3-E111-9657-003048D37694.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/24A74629-C2D3-E111-BA03-E0CB4E55365D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/2493AC9B-ADD3-E111-9DD4-003048F11942.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/24738499-84D3-E111-94CE-BCAEC5329727.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/22AB4F55-72D3-E111-931C-5404A6388698.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/224E95F2-BED3-E111-A0F1-003048F1C424.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/20F5CCCD-84D3-E111-A504-003048D2C020.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1E3C18FF-77D3-E111-AE3B-00237DDBE0E2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1CDE24B2-C2D3-E111-AC19-BCAEC518FF8A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1CA5C264-BAD3-E111-9475-003048CFB40C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1C5CBA7B-A9D3-E111-98EA-5404A63886B6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1A4A16D8-B9D3-E111-82D0-001D09F24303.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1A143B6E-8AD3-E111-8A72-003048D3C932.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/18757DF3-D6D3-E111-AF95-5404A63886BB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/184E844A-D7D3-E111-A5EA-002481E0D646.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/1682D5A6-7FD3-E111-B3AC-001D09F2424A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/12CE676F-A5D3-E111-83FF-BCAEC5329713.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/125FBB6B-D3D3-E111-A795-002481E0D646.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/10F1968E-B8D3-E111-9DE2-003048F11942.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/10DF7D12-B5D3-E111-90C7-BCAEC53296F3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/0CEBA7F5-9AD3-E111-AA21-0025901D5DB8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/0C3EA435-D4D3-E111-A19C-0025901D5DEE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/08FAD2F9-9CD3-E111-A043-00237DDC5BBC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/089DFF83-C0D3-E111-83D4-001D09F2525D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/088DF336-D4D3-E111-8A8F-0025901D626C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/04F32824-B4D3-E111-929F-5404A638869E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/04DBE034-C2D3-E111-A9F9-001D09F2512C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/02746071-79D3-E111-AE2C-003048F1C832.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/199/282/00757C58-90D3-E111-A67D-001D09F248F8.root",
   
## # fill 2858
## ## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/318/E83D7D32-22D4-E111-86A8-BCAEC5364C4C.root",
## ## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/318/B044AF4B-1CD4-E111-B627-BCAEC53296F4.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/318/AC6EBE7D-28D4-E111-88E2-BCAEC518FF7C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/318/32741137-22D4-E111-BE27-00237DDBE49C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/318/3078BF82-3AD4-E111-AB87-BCAEC518FF5F.root",

#"/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/318/0A1A4091-1BD4-E111-B477-0025B32445E0.root",
#"/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/318/5E850A7D-14D4-E111-A1CF-001D09F24303.root",
#"/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/318/B6F59161-12D4-E111-9DC1-001D09F241B9.root",

## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/FEC77CAF-37D4-E111-89F6-003048F118D4.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/FCC70F48-3BD4-E111-9BCB-5404A63886D4.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/FC735283-39D4-E111-AEDF-0025901D624A.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/FC237955-36D4-E111-A15D-003048D37580.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/F68C21AC-65D4-E111-BAD4-00215AEDFD98.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/EE8CEEF7-3BD4-E111-9286-001D09F25267.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/E42D09B3-65D4-E111-AE8C-003048D2BC62.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/E0D88393-6DD4-E111-A04D-001D09F28F25.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/CC84F0F1-4BD4-E111-AC19-0025B3203898.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/C872BC7C-42D4-E111-B3E1-003048D2C0F0.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/C2FA8B79-3AD4-E111-ABE5-5404A640A642.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/B8DC4239-64D4-E111-B78A-001D09F28EA3.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/B610D272-4BD4-E111-B9BB-00215AEDFCCC.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/B2621577-42D4-E111-A456-00237DDBE49C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/B020059C-44D4-E111-8CC7-5404A63886BB.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/AAED13FF-60D4-E111-BE11-001D09F24FEC.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/A85081AB-36D4-E111-BDE1-BCAEC518FF89.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/944ABC82-39D4-E111-A186-5404A63886D4.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/8C262836-32D4-E111-BA7A-BCAEC518FF7C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/803F7641-5DD4-E111-BFDF-001D09F297EF.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/7A5FF783-3ED4-E111-91B8-003048D3733E.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/6CA2B16D-6AD4-E111-9405-003048D2BC62.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/6487F22E-40D4-E111-AC6B-BCAEC5364C42.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/60D0BE63-5ED4-E111-89E0-001D09F24D8A.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/3CA94B62-50D4-E111-96EF-5404A63886EF.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/300FA3D1-6BD4-E111-8B3E-5404A63886EE.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/26B096BA-48D4-E111-A463-00237DDBE49C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/268EB5C2-75D4-E111-9924-0025901D6288.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/26866A5A-45D4-E111-B156-BCAEC5364C93.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/227D17CC-5BD4-E111-95ED-003048F1183E.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/1A35B0DD-74D4-E111-8F08-001D09F23C73.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/162ADE59-4DD4-E111-9A9D-001D09F2512C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/0A0C4CF7-34D4-E111-9513-5404A63886C5.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/04BC0641-3BD4-E111-A555-BCAEC518FF50.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/199/319/027CCF25-57D4-E111-8085-5404A640A648.root",

## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/E66F789D-31D4-E111-9D70-E0CB4E55365C.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/D42C98DB-4BD4-E111-9B15-BCAEC5329717.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/C849CC69-4BD4-E111-AEFA-5404A63886D6.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/C042820D-38D4-E111-9CD3-5404A6388699.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/B090B9F6-6AD4-E111-8291-003048CF99BA.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/AEAB037A-3ED4-E111-9519-003048CF9B28.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/A6D09EEE-61D4-E111-A783-BCAEC518FF8E.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/92035DE3-49D4-E111-B8AE-001D09F24763.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/90E0FE00-5FD4-E111-8FF0-5404A63886BD.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/86763099-54D4-E111-B76E-001D09F24763.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/840734EF-39D4-E111-A450-0025B32036E2.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/7C6E6015-4CD4-E111-A820-0025B32035A2.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/6AAAA6ED-67D4-E111-BF5D-003048D2BF1C.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/689EAFB6-35D4-E111-B9DE-5404A63886B7.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/5CD43F0F-37D4-E111-A691-5404A63886B2.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/4AFC9053-36D4-E111-A14C-003048F024C2.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/3C9B70A2-4ED4-E111-A05D-001D09F28E80.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/3ABEFD30-5DD4-E111-9E09-001D09F2AF96.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/240AE3BF-5DD4-E111-8755-BCAEC5329713.root",
## "/store/data/Run2012C/Commissioning/RECO/PromptReco-v2/000/199/319/22495FAA-37D4-E111-9D1A-003048F1BF68.root",

# 200781 B=0
##  "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/781/7026A08B-6EE6-E111-B3A6-001D09F28F25.root",
##  "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/781/8C9E6FD8-6DE6-E111-AB15-0030486733B4.root",
##  "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/781/B472FDD5-6DE6-E111-B1EC-0025901D5DF4.root",
##  "/store/data/Run2012C/ZeroBias2/RECO/PromptReco-v2/000/200/781/444239C7-77E6-E111-8AB3-00215AEDFD74.root",
##  "/store/data/Run2012C/ZeroBias2/RECO/PromptReco-v2/000/200/781/84EB0AF6-6FE6-E111-8855-0030486780E6.root",
##  "/store/data/Run2012C/ZeroBias2/RECO/PromptReco-v2/000/200/781/C2327DC4-77E6-E111-93C5-003048F118AC.root",
##  "/store/data/Run2012C/ZeroBias3/RECO/PromptReco-v2/000/200/781/0CD53E26-6DE6-E111-972A-001D09F29321.root",
##  "/store/data/Run2012C/ZeroBias3/RECO/PromptReco-v2/000/200/781/1C9ADC26-6DE6-E111-BEA0-003048F118AC.root",
##  "/store/data/Run2012C/ZeroBias3/RECO/PromptReco-v2/000/200/781/DE22D826-6DE6-E111-AE8F-00215AEDFD74.root",
##  "/store/data/Run2012C/ZeroBias4/RECO/PromptReco-v2/000/200/781/66C51627-6DE6-E111-8DE2-BCAEC518FF74.root",
##  "/store/data/Run2012C/ZeroBias4/RECO/PromptReco-v2/000/200/781/96D2EE3A-7BE6-E111-A336-0030486733B4.root",

## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/FECD36CC-ECE7-E111-9223-0025901D5DF4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/FEA90EAA-BFE7-E111-A689-BCAEC518FF74.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/FA546FAA-B2E7-E111-9D08-0025901D5D90.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/FA056E87-DFE7-E111-9C8B-0025B32445E0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F8EA3E8D-07E8-E111-85AC-002481E0D524.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F8DCD02B-D6E7-E111-A14E-00237DDBE49C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F64F390F-E2E7-E111-88D7-003048D2C0F2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F4C5CC90-E5E7-E111-AF76-5404A63886C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F4270EBB-B3E7-E111-8D31-003048D37666.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F2B97040-C8E7-E111-898E-003048D2BC5C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F289A6ED-88E7-E111-97AC-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/F0A40917-2AE7-E111-A262-BCAEC518FF89.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/EEFE0862-46E7-E111-8620-5404A63886C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/EE5F5789-1FE7-E111-8042-003048F024E0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/EAA1C906-88E7-E111-B2E3-003048F118DE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E81F9C63-46E7-E111-9EAB-BCAEC5364CFB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E81767BD-8DE7-E111-AB3F-003048D2BDD8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E48A49F8-7EE7-E111-BE7F-001D09F28E80.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E44AB5AD-F7E7-E111-94F2-BCAEC5329708.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E4194014-0AE8-E111-B00F-003048D37456.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E2AE552A-42E7-E111-8E2C-002481E0CC00.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E2A2C70C-7CE7-E111-B4E5-001D09F27067.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/E0DB057C-C5E6-E111-9E83-001D09F24FEC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/DEE7F4AE-42E8-E111-9667-E0CB4E55367F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/DEE62168-45E7-E111-B456-BCAEC5364CED.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/DE127A7D-38E7-E111-82D3-5404A640A643.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/DC190952-16E7-E111-A369-5404A640A648.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/DA166410-48E7-E111-94CF-BCAEC518FF50.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/D8EC030E-E1E6-E111-853A-003048D3756A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/D617BDA9-D0E7-E111-8228-003048F24A04.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/D4ADE567-0AE8-E111-B723-001D09F29146.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/D4506E65-46E7-E111-AD1A-BCAEC53296F4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/CE8407AA-C2E6-E111-A13F-BCAEC518FF41.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/CC2ADFB0-07E8-E111-A89F-003048F1110E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/CA15954B-A1E7-E111-87B1-BCAEC518FF68.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/C8551D05-7CE7-E111-B951-5404A63886B0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/C6D5EAA1-1AE8-E111-91F0-0025901D624A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/C0B625A4-F3E7-E111-9C2E-BCAEC532971E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/C07D0812-B4E7-E111-8816-0030486780B8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/BC9D8712-14E7-E111-8160-001D09F291D7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/BA452ADE-3FE8-E111-8BDE-E0CB4E55367F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/BA3EB2EE-36E7-E111-9991-5404A63886CE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/BA1171EB-15E8-E111-9E07-003048F24A04.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B8AAA964-C3E7-E111-B97F-002481E94C7E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B83C384F-08E8-E111-A357-003048F117EC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B81C4DCA-48E7-E111-BB87-5404A640A643.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B6B1BCF4-84E7-E111-88EA-002481E0D7D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B2F09DF9-C8E6-E111-A9DC-002481E0D7D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B079F912-40E7-E111-ADC2-001D09F2441B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/B0412B38-A4E6-E111-902E-5404A63886C1.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/ACB25A41-2BE7-E111-A7DF-0025901D625A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/AC9CFFC1-3DE8-E111-BF0D-E0CB4E55367F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/AC6F6642-7FE7-E111-B16C-5404A6388698.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/AAFCE5E8-09E8-E111-BB20-5404A638869C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/AA17B2D7-93E7-E111-85B2-BCAEC5329708.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A882B255-E8E7-E111-AD9C-0025901D5DF4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A80DF0C9-10E7-E111-9A00-BCAEC518FF41.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A6FF0384-52E7-E111-BB8C-002481E0D73C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A612B124-42E7-E111-A046-003048F1182E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A4812A56-E8E7-E111-BA0C-BCAEC532971F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A42AD103-09E8-E111-BB9A-003048D2BC38.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A2A33A5B-9FE7-E111-839F-5404A63886C6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A2809EE2-17E8-E111-A5A0-BCAEC518FF6B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A0F460E4-91E7-E111-A9D6-0025901D5DEE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A0F208DF-1DE8-E111-AA84-001D09F29169.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A0F0964C-34E7-E111-9E7D-003048F117F6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A09E3CB4-40E8-E111-B7C3-001D09F25267.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A030147E-CCE7-E111-9CB3-BCAEC532971B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/A0298DA1-3BE8-E111-84B5-001D09F29114.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/9CE01877-18E8-E111-ACA5-BCAEC518FF8E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/9AFAC9D8-33E8-E111-9AF5-E0CB4E55367F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/9AD41A7C-6BE7-E111-990F-00237DDC5C24.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/961D2CA7-C2E6-E111-932A-5404A63886A8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/94BBB4B9-16E8-E111-B99C-0025901D5E10.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/9024AC47-2CE8-E111-BF11-E0CB4E553673.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/9023509D-1AE8-E111-9398-0025901D631E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8E859DD3-19E7-E111-8274-003048D37694.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8E81632B-1DE8-E111-96F7-001D09F2525D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8C796ED7-43E7-E111-9D0E-003048F024FA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8C3E3CC3-ECE7-E111-BA5C-003048F118C4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/88EB3A2E-67E7-E111-89AF-5404A63886CC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/88C94E1C-8CE7-E111-821D-00237DDC5CB0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/86A52DCC-BEE7-E111-830A-BCAEC532970F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8414AF26-80E7-E111-AE90-5404A63886B2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/840A5CE4-C4E7-E111-A362-003048D2BB58.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/8287223A-B5E7-E111-81C5-BCAEC518FF62.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/826DFABE-26E8-E111-BC28-485B3962633D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/823451A3-93E7-E111-80C1-5404A6388698.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/80863B2A-C3E7-E111-B87B-5404A63886D6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7EC6253E-18E8-E111-9235-0025901D6272.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7EA18D64-C3E7-E111-9814-BCAEC518FF68.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7E88432B-ACE6-E111-839F-001D09F28D54.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7E136395-C3E7-E111-A7B3-00237DDBE0E2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7A4FAAD2-93E7-E111-9816-BCAEC518FF5F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/7A4B7427-6AE7-E111-AA49-00237DDC5C24.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/76CBBC02-7FE7-E111-AD4A-001D09F2447F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/72D5D2DF-AEE6-E111-9DDF-5404A638869B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/728B65AF-8BE7-E111-B5F8-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/723CA5F5-CDE6-E111-A12E-001D09F24D8A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/722D0CAB-8DE7-E111-B4D3-003048D2BC30.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/704CF854-07E8-E111-8792-BCAEC518FF6E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6EFBA375-B2E6-E111-AC73-5404A63886BB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6CCBC1CF-DEE7-E111-AA6B-003048F1BF66.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6C625004-20E8-E111-BE58-003048F117B6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6A98FD85-B9E6-E111-9392-0025901D5C86.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6893E615-56E7-E111-8509-BCAEC518FF41.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/68859900-C6E7-E111-BCC4-003048D2C092.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/66F82236-A0E7-E111-B038-0025901D629C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/66A861E8-D6E7-E111-A0C6-001D09F2512C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/6465FD59-3CE7-E111-BC35-003048D37456.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/625AADE2-E3E6-E111-95E6-5404A63886B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/60A3106A-4DE7-E111-B0A5-0030486780B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5ED0C10F-A3E7-E111-849A-00237DDC5CB0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5EB040D4-C1E6-E111-AF68-003048D2C16E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5E3E5D6D-C3E7-E111-8CCE-002481E0D7C0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5CD2A977-07E8-E111-B051-BCAEC53296F7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5C5CA45D-1FE8-E111-A1FE-001D09F2910A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5A9F24CE-2AE7-E111-8F30-003048F117EA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5851F0D2-90E7-E111-B67B-001D09F297EF.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5845E2CE-EAE7-E111-8343-003048F117B4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/569EBDAB-E0E7-E111-B465-003048F118AA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/567FA57F-07E8-E111-9B63-5404A63886A8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/54FE3DDC-17E8-E111-B119-BCAEC518FF68.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/542C6CF8-3AE8-E111-BCFD-001D09F25267.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5419D1B8-19E8-E111-BBA0-003048F11C28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/52C3DAF4-08E8-E111-9B97-001D09F24664.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/52B9D387-9BE7-E111-9F98-E0CB4E55365D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/52945E7D-1CE8-E111-9957-001D09F2910A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/5055C4CF-37E7-E111-9B6E-BCAEC518FF8D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/500A8D7D-10E8-E111-8D81-E0CB4E4408E3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/4EED44FE-88E7-E111-943E-00215AEDFD98.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/4E5ECB45-CDE6-E111-B5A7-BCAEC518FF44.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/48FE10F6-09E8-E111-97F1-BCAEC518FF6B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/46434494-40E8-E111-817B-001D09F26509.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/44734DE7-CFE7-E111-BE7E-5404A63886AB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/40FE72BD-CAE7-E111-8E20-BCAEC518FF65.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/40C2A0C3-36E8-E111-9711-001D09F29619.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/409BEFC8-E1E7-E111-A4AC-0025B32445E0.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/3AFB8F03-30E7-E111-B140-BCAEC532970F.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/3ACFC54C-32E7-E111-ADA2-BCAEC518FF44.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/3A2CDA1C-F5E7-E111-8C8A-003048678098.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/38B76F4A-08E8-E111-A586-BCAEC518FF6B.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/38B17738-B4E7-E111-B12C-001D09F2A49C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/38A00331-1DE8-E111-93C4-0019B9F4A1D7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/38758183-55E7-E111-AF3B-BCAEC532971D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/36D689DE-A7E6-E111-989A-BCAEC518FF67.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/3658B63E-01E8-E111-B72A-BCAEC532971D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/348C5417-C7E7-E111-9EE3-485B3962633D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/326B536F-B2E6-E111-8473-5404A63886E6.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/30DE3F19-8CE7-E111-BB0C-003048F1C836.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/30AB0E41-C8E7-E111-8B7E-001D09F2512C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/300E756C-7EE7-E111-8621-0025901D5DEE.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/2E4AD4F4-70E7-E111-9E20-BCAEC518FF40.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/2AD18703-95E7-E111-ABF4-003048F11C28.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/2A9668B9-42E8-E111-ADAE-001D09F29321.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/28DA4C22-A5E7-E111-98D5-BCAEC5329719.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/2889C694-E1E7-E111-ABE5-003048D2C16E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/26DF1F06-18E8-E111-9B67-5404A63886B7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/264E7B06-EEE7-E111-977D-001D09F28D54.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/260526BB-36E8-E111-AAA1-001D09F2A465.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/247F656C-CAE6-E111-9921-001D09F2525D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/22AA5E32-1EE7-E111-A1CF-003048D2BA82.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1EF6C2FD-C3E7-E111-8A8F-003048F1182E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1EA56B14-56E7-E111-80ED-0025B32036E2.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1CB66784-30E7-E111-BEFD-BCAEC5364C62.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1C46B2D5-22E7-E111-A017-003048F1182E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1AF70E0C-95E7-E111-8730-003048D37560.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/18CFCC0F-E9E7-E111-8B49-0025901D5C86.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/18A7D8AD-53E7-E111-8A06-001D09F28EA3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/188BAA82-55E7-E111-9054-5404A640A648.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/183ECE04-89E7-E111-93E9-001D09F2424A.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/1677D0BC-6AE7-E111-9789-0030486733D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/16755B54-DBE7-E111-99DB-BCAEC5329700.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/12BE4C0B-F8E7-E111-BC85-BCAEC5329702.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/12B466E7-15E8-E111-AF6D-003048D2C108.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/10542285-83E7-E111-8498-003048F118D4.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/100CD1CD-51E7-E111-979A-0025901D5DB8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0E829C59-D1E7-E111-AB0C-0025901D629C.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0E3D1FA9-C7E6-E111-91B2-5404A63886B7.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0CA54A78-CAE7-E111-8C29-BCAEC518FF54.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0C70B306-EFE7-E111-985E-002481E0D7D8.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0C39A124-70E7-E111-9B6F-001D09F2462D.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0AA7F5A5-F7E6-E111-9C23-BCAEC5329720.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0A908D12-F5E7-E111-803D-5404A63886A5.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0A89708C-2CE7-E111-93A5-0025901D6268.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0A42EC81-E3E7-E111-BBD5-BCAEC518FF6E.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/08CE5605-A3E7-E111-8978-BCAEC518FF41.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/08BCF32F-39E7-E111-8643-0025B32034EA.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/08B7052A-6EE7-E111-BBBC-0030486780EC.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/06E57763-46E7-E111-A27D-0025901D5C86.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/0276AE4F-69E7-E111-9378-5404A63886CB.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/00A1E991-2CE7-E111-9053-E0CB4E4408E3.root",
## "/store/data/Run2012C/ZeroBias1/RECO/PromptReco-v2/000/200/786/001CB74F-16E8-E111-A88F-5404A638869C.root",


## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/F6C1E89C-9DF0-E111-8644-5404A638869B.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/EC8CD0C5-7BF0-E111-8289-003048F118C4.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/E69762EE-89F0-E111-867B-5404A63886C1.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/D270E54A-7CF0-E111-89D7-003048F1BF66.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/BA5C8DB2-89F0-E111-9927-BCAEC53296FB.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/AA33C323-6CF0-E111-939C-003048D37538.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/A28A4B3D-A3F0-E111-93CB-5404A63886C1.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/848C2069-A0F0-E111-A39F-BCAEC518FF7C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/4273B153-94F0-E111-8448-5404A63886B2.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/424FE001-81F0-E111-8481-0030486780A8.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/201/624/2CCCC2EA-8FF0-E111-847A-5404A63886CE.root",

# fill 3071
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/ECC7C56C-5602-E211-9F9B-0025901D6288.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/ECAEE003-6802-E211-8F3A-001D09F244DE.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/EA478775-9002-E211-876D-003048F1C424.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/DAE6F3B5-4F02-E211-838C-003048F117EA.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/C8FF2344-3002-E211-831C-001D09F24399.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/C81042C3-4F02-E211-8B75-003048D374F2.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/BE0759FA-AA02-E211-81E9-001D09F28EA3.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/BC117AA0-9002-E211-BD58-0019B9F4A1D7.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/B8A8DFE1-2E02-E211-894A-485B3977172C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/B6240BBD-6202-E211-9E1A-003048F024FA.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/B4435C66-5A02-E211-BA80-003048D2C0F2.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/B25FEF7D-9002-E211-BFED-001D09F2B30B.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/B22A307C-9002-E211-8DB3-001D09F248F8.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/ACBD22BB-9002-E211-8174-001D09F25479.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/ACAA75AC-5002-E211-AAFB-001D09F25109.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/A8A383BC-5102-E211-B908-0019B9F70468.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/A87FA1FB-2702-E211-98C1-BCAEC5329709.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/A875CB2A-5602-E211-AC21-001D09F23D1D.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/A80C2B6D-9002-E211-B027-003048F1C58C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/A22EEDD8-AA02-E211-8788-0025B32036D2.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/9E45E0C4-2702-E211-8295-0025901D627C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/9CF92AC9-5802-E211-840A-5404A63886BE.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/9CD8087D-3802-E211-B1FC-0019B9F72CE5.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/9A8905B0-4F02-E211-B1C3-001D09F2983F.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/905612D6-9002-E211-9366-001D09F2462D.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/8ED8CE85-9002-E211-8268-BCAEC518FF6B.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/8A167F6E-9002-E211-A753-003048F11CF0.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/866E5AB2-4F02-E211-8833-003048D3756A.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/860A4275-9002-E211-BEE0-0025901D627C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/84D74272-9002-E211-8987-485B39897227.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/849D35AF-4F02-E211-98DA-003048D2BED6.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/80B63F2F-6002-E211-B82E-001D09F29533.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/7EF6DFB7-6202-E211-ACD4-0025B320384C.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/7A8720C9-6502-E211-AC34-003048D2BC52.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/5C9B937B-9002-E211-BEBE-BCAEC518FF74.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/5C5AD239-6102-E211-9C92-5404A640A643.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/524B616C-9002-E211-8D9A-003048F1182E.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/4A7805D9-AA02-E211-AFB5-003048CF94A8.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/4A4296E2-AA02-E211-8916-5404A6388698.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/38A919AC-4F02-E211-AA09-5404A640A648.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/38588776-9002-E211-8EC6-E0CB4E55367F.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/36D448D5-AA02-E211-AFF9-BCAEC5329705.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/2C215F1C-5602-E211-944B-001D09F29524.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/1E23A8F7-BF02-E211-8880-003048678098.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/1C256F6F-9002-E211-86EA-BCAEC518FF8A.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/1AE33299-5002-E211-A138-BCAEC5329717.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/1A3FE904-2802-E211-A156-001D09F29533.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/147F27BA-9002-E211-8934-001D09F24DA8.root",
## "/store/data/Run2012C/MinimumBias/RECO/PromptReco-v2/000/203/002/129CC79C-5702-E211-8F5A-485B3962633D.root",

# fill 3110, 203853
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/203/853/9EECE9DF-B60B-E211-8CFE-001D09F2906A.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/203/853/882B0EC7-B40B-E211-A0F2-001D09F2906A.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/203/853/72D6848D-BF0B-E211-9EA9-003048D2C174.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/203/853/66306A5F-BA0B-E211-830A-003048D2C0F2.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/203/853/1A294A8F-BC0B-E211-AFE5-001D09F2906A.root",


# fill 3138, 204599
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/E084F1DE-0A13-E211-B10B-BCAEC5329708.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/D8D4F5A5-0113-E211-830D-5404A63886BE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/D023509A-0213-E211-8211-001D09F28D54.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/BC3B9A63-1313-E211-AC8E-003048F11114.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/B05DEACF-FF12-E211-B4D4-0025901D624E.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/9A6810DB-1A13-E211-85BF-BCAEC518FF62.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/8A7052CC-1713-E211-B91B-0025B32445E0.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/7A27763C-1413-E211-AFD2-5404A63886BE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/6A4FAC3B-1713-E211-9627-BCAEC518FF74.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/5CCD5414-2613-E211-9657-BCAEC518FF41.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/509B2695-0213-E211-A70C-001D09F28E80.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/4A1E8FCB-FF12-E211-9995-BCAEC518FF89.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/409AC08D-2113-E211-B051-0025901D5DB8.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/3891EADF-2913-E211-9327-0025B32035A2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/204/599/0063F1BF-1713-E211-9620-0025901D62A0.root",

# fill 3207, 205718
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/F2ACC626-DB1D-E211-90A7-003048F024DE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/F2A9F6A8-D61D-E211-87E7-001D09F2437B.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/DEA53A15-FD1D-E211-96E9-0025B3203898.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/DE532F21-DB1D-E211-ABCF-0030486780A8.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/DAF4D3EC-091E-E211-ACF7-5404A640A643.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/D2EC5795-DE1D-E211-A4A3-003048F1C82A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/CA8972E1-231E-E211-8801-001D09F23F2A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/C41C48FD-F01D-E211-AA63-00237DDBE41A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/BE545438-131E-E211-9C78-BCAEC518FF40.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/B8E8D1C6-EC1D-E211-92A6-BCAEC518FF68.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/B8D812FF-051E-E211-83FD-00237DDC5C24.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/8C88DC31-DB1D-E211-AE00-00215AEDFD98.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/8AA894EB-FF1D-E211-82B2-003048D2BC4C.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/84B7A0B7-2D1E-E211-BC40-5404A63886BE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/70060C5E-DC1D-E211-B446-003048F1C58C.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/6090F10F-F81D-E211-896F-003048673374.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/546B4838-F01D-E211-AEA1-003048D2BD28.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/4C3ECC8A-F41D-E211-ABA4-0025901D5DB2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/46F4F880-121E-E211-945D-003048D2BD66.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/3CA30833-241E-E211-AC65-0025901D5DEE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/3A3CC81B-DB1D-E211-A83A-BCAEC5329713.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/32C26601-DE1D-E211-9973-0025B32034EA.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/2E9A731F-E41D-E211-A427-BCAEC518FF50.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/1E563A35-E81D-E211-B94B-BCAEC5329709.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/1E1F7BF3-D91D-E211-8933-002481E0D524.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/1CAE3300-141E-E211-8B6B-00215AEDFD74.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/1AC502BC-E71D-E211-A514-BCAEC518FF54.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/126CB092-5F1E-E211-BFD0-003048F11DE2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/0CF52756-0B1E-E211-89F1-003048D2C108.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/0C9543C3-1E1E-E211-A9FC-001D09F28E80.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/0A1E7E95-081E-E211-B394-BCAEC518FF44.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/205/718/02E36D68-E31D-E211-AF30-003048D37560.root",

# fill 3273 run 206940
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/FA55823C-312C-E211-94AB-001D09F29533.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/ECC47D25-282C-E211-9503-001D09F24D67.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/E4CD3D82-0A2C-E211-B072-0015C5FDE067.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/E241CCA4-372C-E211-8E11-001D09F291D2.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/DEEE805C-1D2C-E211-8ADE-0019B9F72F97.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/D86EF7B2-262C-E211-BEAB-003048F118C6.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/D6E8B8A3-152C-E211-9EBE-001D09F248F8.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/D085A321-392C-E211-901A-BCAEC532971D.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/C6429DA7-152C-E211-99F8-001D09F291D2.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/A86476FE-2C2C-E211-9586-485B3977172C.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/A499F954-272C-E211-A72B-001D09F24763.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/9ED3CFEC-022C-E211-BAB6-003048D3751E.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/98F5F80E-002C-E211-899D-002481E0D7D8.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/92F99AFE-3D2C-E211-86F2-002481E94C7E.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/90B64ABA-262C-E211-B3B9-00237DDBE0E2.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/908CDADC-252C-E211-8EE0-0025901D626C.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/8E953609-322C-E211-92F2-003048678110.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/889E0DED-052C-E211-B0C9-5404A63886AD.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/6A5A3C96-302C-E211-AE1A-001D09F24664.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/68AA4E8D-1A2C-E211-A551-003048D2BA82.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/68735AF9-512C-E211-B0BC-003048D2C0F0.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/5E8892F6-2A2C-E211-B378-001D09F27067.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/5C0FC841-2A2C-E211-AB41-001D09F25267.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/58CCE83B-4C2C-E211-BE24-001D09F24303.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/588B9F22-FF2B-E211-9610-5404A63886CF.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/4CE79042-202C-E211-93A6-003048D2BB58.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/3EC73922-342C-E211-914E-00215AEDFD74.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/3CCA5DF8-422C-E211-8302-0025901D5E10.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/3AC7225A-082C-E211-BEEC-5404A63886C1.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/38DB8AA8-172C-E211-96AD-001D09F23D1D.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/2C797B1E-1F2C-E211-A986-001D09F2983F.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/226FB799-2B2C-E211-9BCA-001D09F23D1D.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/02D3B6A8-152C-E211-9176-001D09F24FBA.root",
"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/206/940/0223D51D-192C-E211-B06D-001D09F29619.root",
    
# fill 3297, 207469
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/469/C2B693B7-5133-E211-ADA5-00215AEDFD98.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/469/B65A3EA3-2D33-E211-9C97-003048D3750A.root",
#"/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/469/9E2D078F-4F33-E211-8A94-5404A63886A9.root",
    
# fill 3298, 207477
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/00F73F89-4133-E211-A502-BCAEC518FF68.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/0217FDEC-6C33-E211-9140-003048F118E0.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/0AA58A41-2733-E211-9FB5-5404A63886B9.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/16DDCC18-4733-E211-9467-5404A63886B0.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/26F62CB2-5133-E211-8EAA-BCAEC518FF65.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/32EEB561-4233-E211-8D13-001D09F25109.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/3CF7C6A1-3333-E211-90E3-5404A63886BD.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/6C568240-4533-E211-87C8-003048F117B6.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/7011A04E-5A33-E211-A9FD-5404A63886EC.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/949ACCAA-3333-E211-8429-5404A63886AE.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/94B1A3F7-7033-E211-A78E-BCAEC532970F.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/9C7F723D-4533-E211-9D0E-003048CF94A6.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/A260E4A3-5D33-E211-BED7-0025B32035A2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/AEE6557E-5233-E211-A218-BCAEC5329702.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/C0D8D082-1533-E211-9A2C-5404A6388692.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/C206CDDA-3133-E211-8A5E-0025B3203898.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/C2219D33-4833-E211-9E9E-5404A63886B2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/C4712C03-2433-E211-9615-001D09F2AD84.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/D6BC2EAD-5133-E211-B0C9-0025901D629C.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/E0A7D205-4C33-E211-A5B4-E0CB4E4408E3.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/E236D88C-7433-E211-8471-003048F1C58C.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/E4A9C446-2733-E211-ACF2-0025901D5E10.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/EC6AA7C0-5B33-E211-85C2-003048673374.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/ECCE1F42-5333-E211-B37D-0019B9F72F97.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/EE59238B-5633-E211-B154-BCAEC5329702.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/207/477/FECFED3C-4533-E211-9699-003048D2BDD8.root",

## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/F60495B3-1E41-E211-BB7C-003048D3756A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/F2BA6B22-2C41-E211-9D7A-003048D2BED6.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/E4E6B318-2041-E211-B351-001D09F29114.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/B27AC385-3241-E211-AD10-0019B9F4A1D7.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/AC6EF0B7-4941-E211-9EFB-003048D374F2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/AA4018D3-2C41-E211-8279-00215AEDFD98.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/A8CF653C-4D41-E211-811E-003048673374.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/98EEEB5E-4A41-E211-A591-001D09F25460.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/96BE2949-2241-E211-9993-001D09F23F2A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/90F6F479-2641-E211-99E5-001D09F29524.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/8AAFC294-2141-E211-89E8-003048F1182E.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/82B885ED-2241-E211-9877-001D09F252E9.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/6440884D-2941-E211-BBA9-0025901D6288.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/604E8D2C-2741-E211-B542-003048F11C28.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/4EB6D745-2241-E211-9738-001D09F24D8A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/3E863C44-2241-E211-9255-001D09F25041.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/3E76F7E8-2741-E211-8249-003048D37666.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/3C1D83B8-3641-E211-8C66-0025B32035A2.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/2A12A045-2241-E211-8BF5-001D09F2915A.root",
## "/store/data/Run2012D/MinimumBias/RECO/PromptReco-v1/000/208/686/1661335F-3041-E211-9B96-00237DDBE0E2.root",

# HI
# fill 3478. r 210534
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/EA29B575-1865-E211-AACC-BCAEC518FF65.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/EA20D405-1865-E211-967D-BCAEC5329716.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/E08072AF-2E65-E211-92B5-001D09F24664.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/DE498BF4-1865-E211-9087-5404A63886C1.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/DAB793F5-1865-E211-A34A-BCAEC5329701.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/D8FA72FD-1865-E211-8ABE-003048F118D2.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/CC0D3101-1965-E211-AD07-BCAEC518FF7E.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/C49A6303-1965-E211-8D40-0025901D624A.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/C2F5B2F1-1865-E211-9CA7-BCAEC532971D.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/C252D102-1965-E211-9CC5-BCAEC518FF6B.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/BCB90CF3-1865-E211-8C66-5404A63886D6.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/B63B290D-2A65-E211-B03D-0030486733D8.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/B491BE5C-1965-E211-9C6B-BCAEC518FF76.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/B0E8D029-1965-E211-97C5-003048D2BE08.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/AA1521EF-1865-E211-BCB4-BCAEC518FF7A.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/A2613BFA-1865-E211-AB55-BCAEC518FF8D.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/9ACFF272-3265-E211-B582-5404A63886B0.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/98763587-4565-E211-94BB-BCAEC5364C62.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/941169FD-1865-E211-8C6C-BCAEC53296F8.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/903C9383-3765-E211-B7A4-5404A63886C1.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/844E8C8A-4565-E211-9753-003048678110.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/7A7F7C09-1965-E211-AF18-BCAEC518FF41.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/74018417-1965-E211-A275-BCAEC518FF74.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/7065AD32-1A65-E211-8415-0025901D5C86.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/6A2E32F6-1865-E211-B3F2-0025901D5C88.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/6498550A-1965-E211-80B2-001D09F28D4A.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/56E9BFDE-2865-E211-8BCA-001D09F24D67.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/4E6E13FB-1865-E211-859A-003048F117EA.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/4CD1BF06-1965-E211-8F2B-003048F11112.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/402CCA76-1865-E211-9F05-0025901D6268.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/3C728574-1865-E211-8F3E-003048F11942.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/3A9CA223-1A65-E211-B733-BCAEC518FF44.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/38E46556-2465-E211-9514-001D09F24664.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/361A1128-1965-E211-A61B-0025901D5D78.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/34D9070B-1965-E211-84B0-BCAEC518FF54.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/3259F06D-1865-E211-B535-003048F024C2.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/2237D1F5-1865-E211-A191-002481E0D7EC.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/164F482C-1965-E211-9A0D-002481E0D524.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/066FF3EC-1A65-E211-B4B0-0025901D5DB2.root",
## "/store/hidata/HIRun2013/PAMinBiasUPC/RECO/PromptReco-v1/000/210/534/00000/0448E6F8-4E65-E211-B7E0-003048D3C980.root",

##"/store/caf/user/venturia/logerrevent_HI2013_express_v1_210634_210635_v14.root"


  )
    
)

#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('124230:26-124230:9999','124030:2-124030:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('190389:40-190389:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('191271:55-191271:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('191718:30-191718:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('193621:58-193621:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('193998:63-193998:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('194050:52-194050:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('194912:52-194912:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('194912:52-194912:330')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('195099:61-195099:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('195109:85-195109:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('196531:61-196531:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('198609:47-198609:112')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('199282:44-199282:1477')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('199318:64-199318:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('200781:72-200781:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('201624:82-201624:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('203002:74-203002:1596')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('203853:122-203853:229')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('204599:72-204599:9999')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('205718:49-205718:734')
process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('206940:0-206940:1027')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('207469:0-207469:51')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('207477:76-207477:570')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('208686:73-208686:463')
#process.source.lumisToProcess = cms.untracked.VLuminosityBlockRange('210534:24-210534:347')

process.TFileService = cms.Service("TFileService",
    fileName = cms.string('h.root')
)

process.load("Configuration.Geometry.GeometryIdeal_cff")
process.load("Configuration.StandardSequences.MagneticField_38T_cff")

# what is this?
# process.load("Configuration.StandardSequences.Services_cff")

# what is this?
#process.load("SimTracker.Configuration.SimTracker_cff")

# needed for global transformation
# process.load("Configuration.StandardSequences.FakeConditions_cff")

process.load("Configuration.StandardSequences.FrontierConditions_GlobalTag_cff")# Choose the global tag here:
process.GlobalTag.globaltag = "GR_P_V40::All"
# process.GlobalTag.globaltag = "GR_P_V28::All"  2012 A&B
# 2011
# process.GlobalTag.globaltag = "GR_P_V20::All"
#  process.GlobalTag.globaltag = "GR_R_311_V2::All"
# 2010
# process.GlobalTag.globaltag = 'GR10_P_V5::All'
# process.GlobalTag.globaltag = 'GR10_P_V4::All'
# OK for 2009 LHC data
#process.GlobalTag.globaltag = 'CRAFT09_R_V4::All'

process.d = cms.EDAnalyzer("TestClusters",
    Verbosity = cms.untracked.bool(False),
    src = cms.InputTag("siPixelClusters"),
    Select1 = cms.untracked.int32(1),  # cut on the num of dets <4 skip, 0 means 4 default 
    Select2 = cms.untracked.int32(0),  # 6 no bptx, 0 no selection                               
)

#process.p = cms.Path(process.hltPhysicsDeclared*process.hltfilter*process.d)
process.p = cms.Path(process.hltPhysicsDeclared*process.d)
#process.p = cms.Path(process.hltfilter*process.d)
#process.p = cms.Path(process.d)


# define an EndPath to analyze all other path results
#process.hltTrigReport = cms.EDAnalyzer( 'HLTrigReport',
#    HLTriggerResults = cms.InputTag( 'TriggerResults','','' )
#)
#process.HLTAnalyzerEndpath = cms.EndPath( process.hltTrigReport )
